<?

function easy_sermon_admin_scripts() {
	wp_enqueue_script('media-upload');
	wp_enqueue_script('thickbox');
	wp_register_script('my-upload', WP_PLUGIN_URL.'/easy-sermon-backend.js', array('jquery','media-upload','thickbox'));
	wp_enqueue_script('my-upload');
}

function easy_sermon_admin_styles() {
	wp_enqueue_style('thickbox');
}

add_action('admin_print_scripts', 'easy_sermon_admin_scripts');
add_action('admin_print_styles', 'easy_sermon_admin_styles');
add_action( 'init', 'create_easy_sermon' );

function create_easy_sermon() {
	register_post_type( 'easysermon',
		array(
			'labels' => array(
				'name' => __( 'Sermons' ),
				'singular_name' => __( 'Sermon' ),
				'add_new' => __( 'Add a new sermon' ),
				'add_new_item' => __( 'Add a new sermon' ),
                'edit_item' => __( 'Edit a sermon' ),
                'new_item' => __( 'Edit a sermon' ),
                'view_item' => __( 'View sermon information' ),
			),
		'supports' => array( 'title', 'editor'),
        'capability_type' => 'post',
		'public' => true,
		'taxonomies' => array('category'),
		'has_archive' => true,
		'rewrite' => array('slug' => 'sermon'),
		'register_meta_box_cb' => 'add_sermon_metaboxes'
		)
	);
	
}

function add_sermon_metaboxes() {
	add_meta_box('wpt_sermon_upload', 'Upload sermon file', 'wpt_sermon_upload', 'easysermon', 'side', 'default');
	add_meta_box('wpt_sermon_url', 'Sermon file location', 'wpt_sermon_url', 'easysermon', 'side', 'default');
}


function wpt_sermon_url() {
    global $post;
 
    // Noncename needed to verify where the data originated
    echo '<input type="hidden" name="sermonmeta_noncename" id="sermonmeta_noncename" value="' .
    wp_create_nonce( plugin_basename(__FILE__) ) . '" />';
 
    // Get the location data if its already been entered
    $url = get_post_meta($post->ID, '_url', true);
 
    // Echo out the field
    echo '<input type="text" name="_url" value="' . $url  . '" class="widefat" />';
 
}

function wpt_sermon_upload() {
    global $post;
 
    // Noncename needed to verify where the data originated
    echo '<input type="hidden" name="sermonmeta_noncename" id="sermonmeta_noncename" value="' .
    wp_create_nonce( plugin_basename(__FILE__) ) . '" />';
 
    // Get the location data if its already been entered
    $url = get_post_meta($post->ID, '_upload', true);
 
    // Echo out the field
    echo '<input type="text" name="_upload" id="upload_sermon" value="' . $url  . '" class="widefat" />';
	echo '<input id="upload_sermon_button" type="button" value="Browse file" />';
	echo '<p>Upload an audio file. Please be aware that some hosts have limits on the size of file that you can upload.</p>';
}

// Save the Metabox Data
 
function wpt_save_sermon_meta($post_id, $post) {
 
    // verify this came from our screen and with proper authorization,
    // because save_post can be triggered at other times
    if ( !wp_verify_nonce( $_POST['sermonmeta_noncename'], plugin_basename(__FILE__) )) {
    return $post->ID;
    }
 
    // Is the user allowed to edit the post or page?
    if ( !current_user_can( 'edit_post', $post->ID ))
        return $post->ID;
 
    // OK, we're authenticated: we need to find and save the data
    // We'll put it into an array to make it easier to loop though.
 
    $sermon_meta['_upload'] = $_POST['_upload'];
	$sermon_meta['_url'] = $_POST['_url'];
 
    // Add values of $events_meta as custom fields
 
    foreach ($sermon_meta as $key => $value) { // Cycle through the $sermon_meta array!
        if( $post->post_type == 'revision' ) return; // Don't store custom data twice
        $value = implode(',', (array)$value); // If $value is an array, make it a CSV (unlikely)
        if(get_post_meta($post->ID, $key, FALSE)) { // If the custom field already has a value
            update_post_meta($post->ID, $key, $value);
        } else { // If the custom field doesn't have a value
            add_post_meta($post->ID, $key, $value);
        }
        if(!$value) delete_post_meta($post->ID, $key); // Delete if blank
    }
 
}
 
add_action('save_post', 'wpt_save_sermon_meta', 1, 2); // save

?>